#include<iostream>
#include<vector>
#include<cmath>
#include<bits/stdc++.h>

using namespace std;

// Does the Anderson-Darling statistical test for a uniform distribution.
// Expects from standard input the count, and then a list of doubles
//   between 0 and 1 exclusive.

int main()
{
  long int size;
  cin >> size;
  vector<long double> list;
  list.resize(size);

  for(int i=0; i<size; i++)
    cin >> list[i];

  sort(list.begin(),list.end());

  long int N=size;
  long double A2=0;
  long double sum=0;
  long double Nl=N;

  for(int i=1; i<=N; i++)
    sum+= (2.0l*i-1)*( logl(list[i-1]) + logl(1-list[N-i]) );
  //sum=sum/N;
  A2=-N-sum/Nl;

  double prob[]={0.25,  0.15,  0.1,  0.05, 0.025, 0.01, 0.005, 0.001};
  double aval[]={1.248, 1.61, 1.933, 2.492, 3.070, 3.88,   4.5, 6.0};
  int len=8;

  cout << "A2=" << A2 << endl;
  
  if(A2<aval[0])
  {
    cout << "bad fit - uniform prob < " << 1-prob[0] << endl;
  }
  else
  {

    for(int i=1; i<len; i++)
    {
      if(aval[i-1]<=A2 && A2<aval[i])
        cout << "Good fit - uniform prob >= " << 1-prob[i-1] << endl;
    }

    if(aval[len-1]<=A2)
      cout << "Good fit - uniform prob >= " << 1-prob[len-1] << endl;
  }

  return 0;
}
