#include<iostream>
#include<fstream>
#include<vector>
#include "ring.h"
#include "estimate.h"
#include "wheel.h"

using namespace std;


vector<Ring> r;
int cutoff;
int k;
long double M;
long double residues;


void makerings()
{
  makesmallprimes(k+1);
  r.resize(primelen);

  residues=1;
  M=1; 

  for(int i=0; i<primelen && prime[i]<=k; i++)
  {
    r[i].init(prime[i],k);
    M*=r[i].m;
    residues*=r[i].numres;
    cutoff=i+1;
  }

}

bool filter(int128 x)
{
  for(int i=cutoff; i<r.size(); i++)
    if(!r[i].ones[x%r[i].m]) return false;
  return true;
}

int main()
{
  //cout << "Enter k: ";
  cin >> k;

  //for(k=10; k<=250; k++) {
  //for(k=266; k<=300; k++) {

  long double limit=estimateg(k);
  //cout << "k="<<k << " Estimate="<<limit<<endl;

  //load the rings
  makerings();

  // make the wheel
  Wheel w;
  w.build(r,cutoff,M);

 // cout << residues-1 << endl;

  //w.print(cout);

  int128 x;
  int count=0;
  x=w.first(k+2);
  do {
    //cout << count++ << ": "<< x << endl;
    cout <<  (x/M) << endl;
    if(w.hasNext())
      x=w.next();
  } while(x>0 && w.hasNext());

/*
  cout << "k=" << k 
       << " modulus=" << M
       << " residues=" << residues
  << endl;
*/

  return 0;
}
