#include<iostream>
#include<fstream>
#include "smallprimes.h"
#include "ring.h"

using namespace std;

const int kmax=16;

int main()
{
  int k;
//  cout << "Enter k: ";
//  cin >> k;

  // load gk.txt
  ifstream gkfile("gk.txt");
  long double g[kmax+1];
  for(int k=1; k<=kmax; k++)
  {
    int kin;
    gkfile >> kin;
    if(kin!=k) cout << "Error! kin="<<kin<<" k="<<k<<endl;
    gkfile >> g[k];

//    cout << k << "\t" << g[k] << endl;
  }

  makesmallprimes(kmax);

  vector<Ring> r;
  r.resize(primelen);
  long double totalsize=0;
  long double totalvalue=0;

  long double modulus=1;
  long double residues=1;

  long double minratio=1;

  for(k=10; k<=kmax; k++) 
  {

    totalsize=0;
    totalvalue=0;

    modulus=1;
    residues=1;

    for(int i=0; i<primelen && prime[i]<=k; i++)
    {
      r[i].init(prime[i],k);
      totalsize+=r[i].size;
      totalvalue+=r[i].value;
      modulus*=r[i].m;
      residues*=r[i].numres;
    }

    cout << k 
         << " " << g[k]
         << "\t " << modulus/residues 
         << "\t ratio=" << modulus/g[k]/residues
         << endl;
    if(modulus/g[k]/residues<minratio) minratio=modulus/g[k]/residues;
    for(int i=0; i<primelen && prime[i]<=k; i++) r[i].print(cout);
    cout << endl;

  }
  cout << "Minimum ratio=" << minratio
       << endl;
  return 0;
}
