#ifndef _ESTIMATE
#define _ESTIMATE

// gives an upper bound estimate for g(k)

const double fudge = 10; // 5 is likely big enough, so 10 is safe, hopefully

#include "smallprimes.h"
#include "ring.h"

long double estimateg(int k)
{
  makesmallprimes(k+1);

  vector<Ring> r;
  r.resize(primelen);

  long double modulus=1;
  long double residues=1;

  for(int i=0; i<primelen && prime[i]<=k; i++)
  {
    r[i].init(prime[i],k);
    modulus*=r[i].m;
    residues*=r[i].numres;
  }

  long double est= fudge*modulus/residues;
  if(est>1e39) return 1e39;
  else return est;
}

#endif
