#include<iostream>
#include<fstream>
#include<vector>
#include "ring.h"
#include "estimate.h"
#include "wheel.h"

using namespace std;


vector<Ring> r;
int cutoff;
int k;

void loadrings()
{
  char filename[]="xxx.txt";
  filename[0]='0'+k/100;
  filename[1]='0'+(k/10)%10;
  filename[2]='0'+k%10;

  ifstream f(filename);
  int numrings, rest;
  f >> numrings >> cutoff >> rest;
  r.resize(numrings);
  for(int i=0; i<numrings; i++)
  {
    int p,a,A;
    f >> p >> a >> A;
    r[i].init(p,k,a);
  }

}

bool filter(int128 x)
{
  for(int i=cutoff; i<r.size(); i++)
    if(!r[i].ones[x%r[i].m]) return false;
  return true;
}

int main()
{
  //cout << "Enter k: ";
  cin >> k;
  
  //cout << "k=" << k << endl;

  //for(k=10; k<=250; k++) {
  //for(k=266; k<=300; k++) {
  {

  long double limit=estimateg(k);
  cout << "k="<<k << " Estimate="<<limit<<endl;

  //load the rings
  loadrings();

  // make the wheel
  Wheel w;
  w.build(r,cutoff,limit);

  w.print(cout);

  int128 min=w.max;
  int128 x;
  x=w.first(k+2);
  do {
    if(x>k+1 && x<min && filter(x)) { if(x<min) w.max=x; min=x; }
    if(w.hasNext())
      x=w.next();
  } while(x>0 && w.hasNext());

  if(x>k+1 && filter(x)) { if(x<min) w.max=min=x; }
  cout << k << " " << min << endl;

  }
}
