#include<iostream>
#include "smallprimes.h"
#include "ring.h"

void sortbyratio(vector<Ring> &r) // uses selection sort
{
  for(int i=0; i+1<r.size(); i++)
  {
    for(int j=i+1; j<r.size(); j++)
      if(r[j].ratio>r[i].ratio)
        { Ring x=r[j]; r[j]=r[i]; r[i]=x; }
  }
}

int main()
{
  int k;
  double target;
  cout << "Enter k: ";
  cin >> k;
  cout << "Enter g(k) estimate: ";
  cin >> target;

  makesmallprimes(k);

  vector<Ring> r;
  r.resize(primelen);
  for(int i=0; i<primelen; i++)
  {
    r[i].init(prime[i],k);
  }

  // do splitting
  for(int i=0; i<primelen; i++)
  {
    Ring x;
    if(r[i].asplit_simple()<r[i].A)
    {
      // do the split
      x.init(r[i].p,k,r[i].asplit_simple());
      r[i].split=x.split=true;
      r[i].babya=x.a;
      r[i].makeknap();
      r.push_back(r[i]);
      r[i]=x;
    }
  }

  sortbyratio(r);

  double totalsize=0;
  double totalvalue=0;

  double modulus=1;
  double residues=1;

  for(int i=0; i<r.size(); i++)
  {
    if(totalsize<log(target))
    {
      totalsize+=r[i].size;
      totalvalue+=r[i].value;
      r[i].print(cout);
    }
  }
  cout << "Total size=" << totalsize
       << " Total value=" << totalvalue
       << " ratio=" << totalvalue/totalsize 
       << endl;
  return 0;
}
